#include "common.h"
#include "method.h"
#include "resource.h"
#include "tp_stub.h"
#include <cstdio>

using namespace std;

func_info _info;
static HANDLE hStdOut;

unsigned int create_archive(const wchar_t* str) {
	ttstr fname(str);
	unsigned int res;
	__asm {
		lea eax, fname
		call _info.open_archive;
		mov res, eax
	}
	return res;
}

static int last_pos_x = 0;
static int last_pos_y = 0;

static void updata_last_pos() {
	CONSOLE_SCREEN_BUFFER_INFO info;
	GetConsoleScreenBufferInfo(hStdOut, &info);
	last_pos_x = info.dwCursorPosition.X;
	last_pos_y = info.dwCursorPosition.Y;
}

void print_log_screen_inter (const wchar_t* s, int reline) {
	DWORD tmp, tmp2;
	std::wstring str = s;
	if (reline) {
		str += TEXT("\r\n");
	}
	WriteConsole(hStdOut, str.c_str(), str.size(), &tmp, &tmp2);
	updata_last_pos();
}

void update_last_info_inter (unsigned int finished, unsigned int total){
	std::wstring res = int2str(finished) + L" / " + int2str(total) + TEXT("   \r\n");
	COORD pos;
	pos.X = last_pos_x;
	pos.Y = last_pos_y;
	SetConsoleCursorPosition(hStdOut,pos);
	DWORD tmp, tmp2;
	WriteConsole(hStdOut, res.c_str(), res.size(), &tmp, &tmp2);
}

void start_interactive() {
	closed = 0;
	if (seach_infomation(&_info) != 0) {
		print_log(L"failed when search infomation.");
		return ;
	}
	print_log(get_dump_path().c_str());
	print_log(L"method 2 - Infomations:");
	print_log((L"construct func = 0x" + hex2str(_info.arc_construct_begin)).c_str());
	print_log((L"open arc func = 0x" + hex2str(_info.open_archive)).c_str());

	AllocConsole();
	hStdOut = GetStdHandle(STD_OUTPUT_HANDLE);
	freopen("CONOUT$", "w", stdout);
	freopen("CONIN$", "r", stdin);

	print_log_screen = print_log_screen_inter;
	update_last_info = update_last_info_inter;

	printf("xp3dumper - interactive mode.\n");
	char buffer[1024];
	wchar_t nbuffer[1024];
	while (scanf("%s", buffer) != EOF) {
		if (strcmp(buffer, "exit") == 0 || buffer[0] == 0) {
			return;
		}

		if (buffer[0] == L'@') {
			TVPExecuteScript(buffer + 1);
			continue;
		}


		int len = sizeof(buffer) + 1;
		MultiByteToWideChar(CP_ACP, 0, buffer, len, nbuffer, len);
		print_log(nbuffer);
		SetConsoleTextAttribute(hStdOut, FOREGROUND_INTENSITY | FOREGROUND_RED);
		print_log_screen(nbuffer, 0);
		print_log_screen(TEXT(" "), 0);
		SetConsoleTextAttribute(hStdOut, FOREGROUND_GREEN);
		int i = 0;
		while (nbuffer[i] != 0) ++i; --i;
		while (i > -1 && nbuffer[i] != '/' && nbuffer[i] != '\\') --i;
		std::wstring path = nbuffer + i + 1;
		path = get_dump_path() + (L"\\" + path);
		unsigned int handle = create_archive(format_path(nbuffer).c_str());
		if (handle) {
			PngAddXp3(nbuffer);
			unpack_archive(handle, path.c_str());
		} else {
			print_log(L"failed initialize");
			print_log_screen(L"failed open archive!");
		}
		SetConsoleTextAttribute(hStdOut, FOREGROUND_GREEN | FOREGROUND_BLUE | FOREGROUND_RED);
	}
}

// mode 3 : dll inject

void start_dllinject() {
	char buffer[512];
	closed = 0;
	if (seach_infomation(&_info) != 0) {
		print_log(L"failed when search infomation.");
		return ;
	}
	print_log(get_dump_path().c_str());
	print_log(L"Method 3 - DLL Inject Mode: ");
	print_log((L"construct func = 0x" + hex2str(_info.arc_construct_begin)).c_str());
	print_log((L"open arc func = 0x" + hex2str(_info.open_archive)).c_str());
	print_log(L"");

	FILE * file = fopen("arc_list.txt", "r");
	if (file == NULL) {
		print_log(L"failed open arc_list.txt");
		return;
	} else {
		while (fscanf( file, "%[^\n]", buffer ) != EOF) {
			fscanf( file, "\n");
			wchar_t buf[1024];
			int len = MultiByteToWideChar(CP_ACP, 0, buffer, sizeof(buffer), buf, sizeof(buf));
			buf[len] = 0;
			print_log((std::wstring(L"Trying to unpack ") + buf).c_str());
			unsigned int handle = create_archive(format_path(buf).c_str());
			if (handle) {
				int i = 0;
				while (buf[i]) ++i;
				while (i && buf[i] != '/' && buf[i] != '\\') --i;
				unpack_archive(handle, (get_dump_path() + (i?L"":L"\\") + (buf + i) ).c_str()) ;
			} else {
				print_log((L"failed create object : " + wstring(buf)).c_str());
				print_log_screen(L"failed open archive!");
			}
		}
	}
}