#include <windows.h>
#include <iostream>
#include <cstdio>
#include "winsock.h"
#include "ws2tcpip.h"

const int port = 12000;
typedef struct {
	unsigned int hash;
	unsigned long long offset;
	void * Buffer;
	long BufferSize;
} buf_info;

void proc_error(const char * str) {
	MessageBoxA(GetDesktopWindow(), str, "xp3maker", 0);
	ExitProcess(0);
}
	
//==========================================================================
int get_data(int sock, void* buf, int len) {
    int size = 0, rec = 0;
    while (size < len) {
        rec = recv ( sock, (char*)buf+size, len-size, 0 );
        if (rec == -1) {
            return -1;
        } else {
            size += rec;
        }
    }
    return 0;
}

int send_data(int sock, void* buf, int len) {
    int size = 0, rec = 0;
    while (size < len) {
        rec = send ( sock, (char*)buf+size, len-size, 0 );
        if (rec == -1) {
            return -1;
        } else {
            size += rec;
        }
    }
    return 0;
}

int has_connect = 0;
int sock;

void connect_to_server() {
	WSADATA winsockdata;
	int res;
	res = WSAStartup( MAKEWORD(2, 2), &winsockdata);
	if (res != 0) {
		proc_error("failed initialize winsock");
	}
	sock = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
	if (sock == 1) {
		proc_error("failed create socket");
	}
	struct sockaddr_in socketaddress;
	socketaddress.sin_family = AF_INET;
	socketaddress.sin_port = htons ( port );
	socketaddress.sin_addr.s_addr = inet_addr ( "127.0.0.1" );
	memset ( &(socketaddress.sin_zero), 0, 8 );

	if (connect( sock, (sockaddr*)&socketaddress, sizeof(struct sockaddr)) ) {
		proc_error("Connect Server Error\n");
	}
	has_connect = 1;
}

extern "C" void __stdcall XP3ArchiveAttractFilter_v2(
	unsigned __int32 hash,
	unsigned __int64 offset, void * buffer, long bufferlen)
{
	if (!has_connect) {
		has_connect = 1;
		connect_to_server();
	}
	buf_info data;
	data.hash = hash;
	data.offset = offset;
	data.BufferSize = bufferlen;
	if (send_data(sock, &data, sizeof(buf_info))){
		proc_error(	"failed send info data" );
	}
	if (send_data(sock, buffer, bufferlen)) {
		proc_error( "failed send buffer data" );
	}
	if (get_data(sock, buffer, bufferlen)) {
		proc_error( "failed get enc buffer data" );
	}
}

