#include <windows.h>
#include <iostream>
#include <cstdio>
#include "tp_stub.h"
#include "winsock.h"
//#include "ws2tcpip.h"

const int port = 12000;

void (TVP_tTVPXP3ArchiveExtractionFilter_CONVENTION * funcPointer) (tTVPXP3ExtractionFilterInfo *);
typedef struct {
	unsigned int hash;
	unsigned __int64 offset;
	void * Buffer;
	long BufferSize;
} buf_info;
	
unsigned char* standard_buffer;

/* guess_result(old version);
int guess_result(buf_info * data) {
	unsigned char* gbuffer = (unsigned char*)data->Buffer;
	int i, j;
	for (i = 0; i < data->BufferSize; ++i) {
		tTVPXP3ExtractionFilterInfo info(data->offset + i, gbuffer + i, 1, data->hash);
		for (j = 0; j < 256; ++j) {
			gbuffer[i] = j;
			funcPointer(&info);
			if (gbuffer[i] == standard_buffer[i]) {
				gbuffer[i] = j;
				break;
			}
		}
		if (j == 256) {
			printf("failed poss = %d, standard_buffer[i] =\n", i, standard_buffer[i]);
			return -1;
		}
	}
	return 0;
	}*/
	
void _cdecl CallFunc(tTVPXP3ExtractionFilterInfo* info) {

	CONTEXT context;
	GetThreadContext(GetCurrentThread(), &context);
	context.Dr0 = 0x00400000;
	SetThreadContext(GetCurrentThread(), &context);

	__try {
		__asm {
			push info
			push 0x00400000
			jmp funcPointer
		}
		//funcPointer(info);
	} __except(1) {
		
	}
}

const int block_size = 2048;
int guess_result(buf_info *data) {
	int flag[block_size];
	int i = 0, j, k;
	
	for (i = 0; i < data->BufferSize; i+=block_size) {
		int size = data->BufferSize - i;
		if (size > block_size) {
			size = block_size;
		}
		memset( flag, 255, sizeof(flag) );
		tTVPXP3ExtractionFilterInfo info(data->offset + i, (char*)data->Buffer + i, size, data->hash);
		memset( data->Buffer, 0, data->BufferSize );
		for (j = 0; j < 256; ++j) {
			int finish = 1;
			unsigned char * pter = (unsigned char*) info.Buffer;
			for (k = 0; k < size; ++k) {
				*pter++ = j;
			}
			
			CallFunc(&info);
			
			for (k = 0; k < size; ++k)
				if (flag[k] < 0 && ((unsigned char*)info.Buffer)[k] == standard_buffer[k + i]) {
					flag[k] = j;
				} else if (flag[k] < 0) {
					finish = 0;
				}
			if (finish) break;
		}
		if (j == 256) {
			return -1;
		}
		for (k = 0; k < size; ++k) {
			((unsigned char*)info.Buffer)[k] = flag[k];
		}
	}
	return 0;
}


//==========================================================================
int get_data(int sock, void* buf, int len) {
    int size = 0, rec = 0;
    while (size < len) {
        rec = recv ( sock, (char*)buf+size, len-size, 0 );
        if (rec == -1) {
            return -1;
        } else {
            size += rec;
            if (rec == 0) {
                printf("[warning]there maybe some problem reciving data?\n");
            }
        }
    }
    return 0;
}

int send_data(int sock, void* buf, int len) {
    int size = 0, rec = 0;
    while (size < len) {
        rec = send ( sock, (char*)buf+size, len-size, 0 );
        if (rec == -1) {
            return -1;
        } else {
            size += rec;
            if (rec == 0) {
                printf("[warning]there maybe some problem sending data?\n");
            }
        }
    }
    return 0;
}



void start_listen() {
	WSADATA winsockdata;
	int res;
	res = WSAStartup( MAKEWORD(2, 2), &winsockdata);
	if (res != 0) {
		printf("failed initialize winsock : %d\n", res);
		return;
	}

	int sock = socket ( AF_INET, SOCK_STREAM, IPPROTO_TCP );
	if (sock == -1) {
		printf("failed create socket : %d\n", WSAGetLastError());
		return ;
	}

	struct sockaddr_in socketaddress;
	socketaddress.sin_family = AF_INET;
	socketaddress.sin_port = htons ( port );
	socketaddress.sin_addr.s_addr = inet_addr ( "127.0.0.1" );
	memset ( &(socketaddress.sin_zero), 0, 8 );
	if ( bind ( sock, (struct sockaddr *) &socketaddress, sizeof(struct sockaddr)) == -1) {
		printf("failed bind socket : %d\n", WSAGetLastError());
		return ;
	}

	res = listen( sock, 1);
	if (res != 0) {
		printf("failed listen : %d\n", res);
		return ;
	}

	int datasock;
	int sa_size = sizeof ( struct sockaddr_in );
	printf("start listenning ... ");
rewaitconnect:
		
	datasock = accept ( sock, (struct sockaddr*)&socketaddress, &sa_size );
	if (datasock == -1) {
           printf("failed connect\n");
           return ;
        }
        printf("connect accept\n");
        while (true) {
            Sleep(1);
/*
            unsigned char cmd;

            if (get_data(datasock, &cmd, 1)) {
               printf("error getting data: %d\n", WSAGetLastError());
               return ;
            }
*/
            buf_info info;
            if (get_data(datasock, &info, sizeof(info))) {
               printf("error getting data: %d\n", WSAGetLastError());
               return ;
            }

            printf("recive work : size = %d", info.BufferSize);
            void * buffer = malloc(info.BufferSize);
            void * tmp_buffer = malloc(info.BufferSize);
            if (buffer == NULL || tmp_buffer == NULL) {
                printf("failed create buffer\n");
                return ;
            }
            if (get_data(datasock, buffer, info.BufferSize)) {
               printf("error getting data: %d\n", WSAGetLastError());
               return ;
            }
            standard_buffer = (unsigned char*) buffer;
            info.Buffer = tmp_buffer;
            if (guess_result(&info)) {
               printf("failed encode data\n");
               return ;
            }
            if (send_data(datasock, tmp_buffer, info.BufferSize)) {
               printf("failed send data\n");
               return ;
            }
	    printf("  finished\n");
            free(buffer);
            free(tmp_buffer);
        }
}


//==========================================================================

void InitOutput() {
	AllocConsole();
	freopen("CONOUT$", "w", stdout);
}

void auto_guess_place() {
	static char funcname[] = "void ::TVPSetXP3ArchiveExtractionFilter(tTVPXP3ArchiveExtractionFilter)";
	unsigned char * extrator = (unsigned char* )TVPGetImportFuncPtr(funcname);
	while (*extrator != 0xe8) ++extrator;
	unsigned int *v  = (unsigned int *) (extrator +  1);
 	while (*extrator == 0xe8) {
		extrator += *v + 5;
		v  = (unsigned int *) (extrator + 1);
	}
	
	funcPointer = (void (TVP_tTVPXP3ArchiveExtractionFilter_CONVENTION *) (tTVPXP3ExtractionFilterInfo *)) **(DWORD**)v;
}


//---------------------------------------------------------------------------
extern "C" HRESULT _stdcall V2Link(iTVPFunctionExporter *exporter)
{
	TVPInitImportStub(exporter);
	InitOutput();

	printf(" XP3Maker v0.02 \n Author: Resty\n");

	FILE * fp = fopen("xp3maker.txt", "r");
	if (fp == NULL) {
		printf("try to search address automatic.\n");
		auto_guess_place();
	} else {
		printf("xp3maker.txt founded!\n");
		unsigned int v;
		scanf("%x", &v);
		funcPointer = (void (TVP_tTVPXP3ArchiveExtractionFilter_CONVENTION *) (tTVPXP3ExtractionFilterInfo *)) *(DWORD*)v;
		fclose(fp);
	}

	printf("\n funcPointer : 0x%08x", funcPointer);
	printf("\n");
	start_listen();
	return S_OK;
}
//---------------------------------------------------------------------------
extern "C" HRESULT _stdcall V2Unlink()
{
	TVPUninitImportStub();
	return S_OK;
}
//---------------------------------------------------------------------------
